--import "WalmPlugins.PimpYourText.ComboBox";
import "WalmPlugins.PimpYourText.DropDown";
import "WalmPlugins.PimpYourText.UTF";
import "WalmPlugins.PimpYourText.GenericTooltip";
import "WalmPlugins.PimpYourText.ColorSelector";


PimpYourTextDialog = class( Turbine.UI.Lotro.Window );

function PimpYourTextDialog:Constructor()
	Turbine.UI.Lotro.Window.Constructor( self );
	
	self:SetSize( settings.mwindow_width or 350, settings.mwindow_height or 205 );
	self:SetPosition( settings.main_x, settings.main_y);
	self:SetVisible(false);
	
	self:SetText( "Pimp Your Text !" );	
	
	-- Build GUI and logicals
	self:CreateComponents();
	
	self.PositionChanged = function(sender, args)
		settings.main_x, settings.main_y = self:GetPosition();
		Savesettings();
	end	
	
	self.Closed = function(sender, args)
		Turbine.Shell.WriteLine(_("HIDE"));
		self:Stop();
	end
	
	self.localBuffer = {};
	self:SwitchTab((settings.currenttab or 1)-1, true);
	self:UpdateValidationButton();
	self:UpdateResponsive();
end

function PimpYourTextDialog:CreateComponents()
	-- Custom text to send
	self.textArea = Turbine.UI.Lotro.TextBox();
	self.textArea:SetParent( self );
	self.textArea:SetPosition( 25, 55 );
	self.textArea:SetFont(Turbine.UI.Lotro.Font.Verdana16);

	self.textArea.FocusLost = function()
		self:UpdateValidationButton();
	end
	-- API BUG => bad mgnt of scrollbars
	local scrollBar = Turbine.UI.Lotro.ScrollBar();
    scrollBar:SetOrientation( Turbine.UI.Orientation.Vertical );
    scrollBar:SetParent( self );
    scrollBar:SetPosition( self.textArea:GetLeft()+self.textArea:GetWidth(), self.textArea:GetTop() );
    scrollBar:SetSize( 10, self.textArea:GetHeight() );
	self.textArea:SetVerticalScrollBar( scrollBar );

	-- Create childs GUIs
	self:CreateToolscomponents();
	self:CreateSwitchComponents();
	self:CreateColorComponents();
	self:CreateDestComponents();
	self:CreateGeneratorComponents();
	
	self.resizer = Turbine.UI.Label();
	self.resizer:SetParent( self );
	self.resizer:SetSize(45, 45);
	self.resizer:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.resizer:SetBackground("WalmPlugins/PimpYourText/pictures/panel_resize_icon.tga");
	self.resizer:SetZOrder(self:GetZOrder()+10);
	self.resizer.MouseDown = function( sender, args )
		if(args.Button == Turbine.UI.MouseButton.Left) then
			sender.dragStartX = args.X;
			sender.dragStartY = args.Y;
			sender.dragging = true;
			sender.dragged = false;
		end
	end
	self.resizer.MouseUp = function( sender, args )
		if (args.Button == Turbine.UI.MouseButton.Left) then			
			if (sender.dragging) then
				sender.dragging = false;
			end
			settings.mwindow_height = self:GetHeight();
			settings.mwindow_width = self:GetWidth();
			Savesettings();
		end
	end
	self.resizer.MouseMove = function(sender,args)
		if ( sender.dragging ) then
			local height = self:GetHeight() + args.Y - sender.dragStartY;
			local width = self:GetWidth() + args.X - sender.dragStartX;
			if(height>207) then 
				self:SetHeight(height);
				self:UpdateResponsive();
			end
			if(width>350) then 
				self:SetWidth(width);
				self:UpdateResponsive();
			end
			self:UpdateResponsive();
		end
	end	
end

function PimpYourTextDialog:CreateColorComponents()
	self.colorTypeList = {_("COLOR_T1"), _("COLOR_T2"), _("COLOR_T3")};
	self.colorTypeDropDown = DropDown.Create(self.colorTypeList, self.colorTypeList[settings.mwindow_height or 1]); 
	self.colorTypeDropDown:SetParent(self);
	self.colorTypeDropDown.myElementList = elementList;
	self.colorTypeDropDown:ApplyWidth(200);
	self.colorTypeDropDown.ItemChanged = function ()
		for i=1, table.getn(self.canalList), 1 do
			-- DAMNED LOOP replacing the combobox lack of returning infos
			if(self.colorTypeList[i]==self.colorTypeDropDown:GetText()) then
				self.color0Selector:SetVisible(i==1);
				self.color1Selector:SetVisible(i==3);
				self.color2Selector:SetVisible(i==3);
				self.colortagBtn:SetVisible(i==1);
				self.colorTypeId = i;
				self:UpdateValidationButton();
				break;
			end
		end	
	end	
	
	self.colorList={_("COLOR_DEF"), _("COLOR_W"), _("COLOR_R"), _("COLOR_Y"),_("COLOR_G"), _("COLOR_B"), _("COLOR_P"), _("COLOR_X")};
	self.rgbList={nil, "FFFFFF", "FF0000", "FFFF00", "00FF00", "38E5DF", "FF5CCD"};
	self.color0List={_("COLOR_W"), _("COLOR_R"), _("COLOR_Y"),_("COLOR_G"), _("COLOR_B"), _("COLOR_P"), _("COLOR_X")};
	self.rgb0List={"FFFFFF", "FF0000", "FFFF00", "00FF00", "38E5DF", "FF5CCD"};	
	self.color0Selector = ColorSelector(self.colorList, self.rgbList, self.UpdateValidationButton); 
	self.color0Selector:SetParent(self); 
	self.color1Selector = ColorSelector(self.color0List, self.rgb0List, self.UpdateValidationButton); 
	self.color1Selector:SetParent(self); 
	self.color2Selector = ColorSelector(self.color0List, self.rgb0List, self.UpdateValidationButton); 
	self.color2Selector:SetParent(self); 
end

-- Create Chanels components (DropDown box and textbox) and logical
function PimpYourTextDialog:CreateDestComponents()
	local label = Turbine.UI.Label();
	label:SetParent( self );
	label:SetPosition(15, 39);
	label:SetSize( 150, 20 );
	label:SetMultiline(false);
	label:SetText(_("CHANNEL"));

	-- Insert in this field your buddy' name
	self.destArea = Turbine.UI.Lotro.TextBox();
	self.destArea:SetParent( self );
	self.destArea:SetPosition( 240, 33 );
	self.destArea:SetSize( 70, 20 );
	self.destArea:SetMultiline(false);
	self.destArea:SetText("");
	self.destArea:SetEnabled(false);
	self.destArea:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	self.destArea.FocusLost = function ()
		-- Damn, your buddy has an empty name... too cruel to be real !
		if(string.len(self.destArea:GetText())==0) then
			Turbine.Shell.WriteLine(_("ERROR_DEST"));
		else
			-- Okay, let's update the sending button !
			self:UpdateValidationButton();
		end
	end
	
	-- Combobox with channels list
	self.canalList={_("CHANNEL_TALK"), _("CHANNEL_COMM"), _("CHANNEL_CONF"), _("CHANNEL_RAID"), _("CHANNEL_WORLD"), _("CHANNEL_OFF"), _("CHANNEL_MDJ"), _("CHANNEL_CUST1"), _("CHANNEL_CUST2"), _("CHANNEL_CUST3"), _("CHANNEL_CUST4"), _("CHANNEL_CUST5"), _("CHANNEL_CUST6"), _("CHANNEL_CUST7"), _("CHANNEL_CUST8"), _("CHANNEL_MI")};
	self.commandList={_("CHANNEL_TALK_C"), _("CHANNEL_COMM_C"), _("CHANNEL_CONF_C"), _("CHANNEL_RAID_C"), _("CHANNEL_WORLD_C"), _("CHANNEL_OFF_C"), _("CHANNEL_MDJ_C"), _("CHANNEL_CUST1_C"), _("CHANNEL_CUST2_C"), _("CHANNEL_CUST3_C"), _("CHANNEL_CUST4_C"), _("CHANNEL_CUST5_C"), _("CHANNEL_CUST6_C"), _("CHANNEL_CUST7_C"), _("CHANNEL_CUST8_C"), _("CHANNEL_MI_C")};	
	self.commandid = 1;
	if(settings.loadData~=nil and settings.loadData.command~=nil) then
		self.commandid = settings.loadData.command;
	end
	
	self.command = self.commandList[self.commandid];
	self.commandDropDown = DropDown.Create(self.canalList, self.canalList[self.commandid]);
	self.commandDropDown:SetParent(self);
	self.commandDropDown:SetPosition(80, self.destArea:GetTop());
	self.commandDropDown.myElementList = elementList;
	self.commandDropDown:ApplyWidth(150);
	self.commandDropDown:SetMaxItems(11);
	self.commandDropDown.ItemChanged = function ()
		for i=1, table.getn(self.canalList), 1 do
			-- DAMNED LOOP replacing the combobox lack of returning infos
			if(self.canalList[i]==self.commandDropDown:GetText()) then
				if(i==table.getn(self.commandList)) then
					-- Selected MP, so write your buddy' name
					self.destArea:SetEnabled(true);
					self.destArea:SetVisible(true);
					self.destArea:Focus();
					self.command = self.commandList[i];
				else
					-- Selectd basic channel
					self.destArea:SetText("");
					self.destArea:SetEnabled(false);
					self.destArea:SetVisible(true);
					self.command = self.commandList[i];
					self:UpdateValidationButton();
				end
				self.commandid = i;
				break;
			end
		end	
	end
	self.destArea:SetEnabled(self.commandid==table.getn(self.commandList));
	self.destArea:SetVisible(self.commandid==table.getn(self.commandList));	
end

function PimpYourTextDialog:CreateSwitchComponents()
	self.tabLabel = Turbine.UI.Label();
	self.tabLabel:SetParent( self );
	self.tabLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16);
	self.tabLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	self.tabLabel:SetForeColor(Turbine.UI.Color( 1, 223/255, 0 ));
	self.tabLabel:SetText("1");
	self.tabLabel.selectedValue = 1;
	self.tabLabel:SetPosition( 8, 100);
	self.tabLabel:SetSize(16, 16);		
	
	self.upBtn = Turbine.UI.Control();
	self.upBtn:SetParent( self );
	self.upBtn:SetBackground( "WalmPlugins/PimpYourText/pictures/scrollbar_10_downarrow.tga" );
	self.upBtn.tooltip = GenericTooltip(self.upBtn);
	self.upBtn.tooltip:AddLayer(_("TAB_UP"), Turbine.UI.Color(1,1,1), Turbine.UI.ContentAlignment.TopLeft, Turbine.UI.Lotro.Font.Verdana14, nil);	
	self.upBtn:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.upBtn:SetPosition( 11, self.tabLabel:GetTop()-20);
	self.upBtn:SetSize(10, 10);	
	self.upBtn.MouseClick = function(sender, args)
		self:SwitchTab(1);
	end
	
	self.downBtn = Turbine.UI.Control();
	self.downBtn:SetParent( self );
	self.downBtn:SetBackground( "WalmPlugins/PimpYourText/pictures/scrollbar_10_uparrow.tga" );
	self.downBtn.tooltip = GenericTooltip(self.downBtn);
	self.downBtn.tooltip:AddLayer(_("TAB_DOWN"), Turbine.UI.Color(1,1,1), Turbine.UI.ContentAlignment.TopLeft, Turbine.UI.Lotro.Font.Verdana14, nil);		
	self.downBtn:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.downBtn:SetPosition( 11, self.tabLabel:GetTop()+25);
	self.downBtn:SetSize(10, 10);		
	self.downBtn.MouseClick = function(sender, args)
		self:SwitchTab(-1);
	end	
end

function PimpYourTextDialog:CreateToolscomponents()
	self.resetBtn = Turbine.UI.Label();
	self.resetBtn:SetParent( self );
	self.resetBtn:SetBackground( "WalmPlugins/PimpYourText/pictures/close.jpg" );
	self.resetBtn:SetSize(16, 16);
	--resetBtn:SetMouseVisible( false );
	self.resetBtn:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	--self.resetBtn.tooltip = ToolTip(self.resetBtn, _("RESET"), _("RESET_BTN"), ToolTipLayout.XSMALL_TEXTONLY);
	self.resetBtn.tooltip = GenericTooltip(self.resetBtn);
	self.resetBtn.tooltip:AddLayer(_("RESET_BTN"), Turbine.UI.Color(1,1,1), Turbine.UI.ContentAlignment.TopLeft, Turbine.UI.Lotro.Font.Verdana14, nil);		
	self.resetBtn.MouseClick = function(sender, args)
		self.textArea:SetText("");
	end
	
	self.saveBtn = Turbine.UI.Label();
	self.saveBtn:SetParent( self );
	self.saveBtn:SetBackground( "WalmPlugins/PimpYourText/pictures/plume.jpg" );
	self.saveBtn:SetSize(16, 16);
	--self.saveBtn.tooltip = ToolTip(self.saveBtn, _("SAVE"),  _("SAVE_BTN"), ToolTipLayout.XSMALL_TEXTONLY);
	self.saveBtn.tooltip = GenericTooltip(self.saveBtn);
	self.saveBtn.tooltip:AddLayer(_("SAVE_BTN"), Turbine.UI.Color(1,1,1), Turbine.UI.ContentAlignment.TopLeft, Turbine.UI.Lotro.Font.Verdana14, nil);		
	self.saveBtn:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );	
	self.saveBtn.MouseClick = function(sender, args)
		if(settings.loadData==nil) then settings.loadData = {}; end
		if(settings.loadData[self.tabLabel.selectedValue]==nil) then settings.loadData[self.tabLabel.selectedValue] = {}; end
		settings.loadData[self.tabLabel.selectedValue] = {
			colorTypeId = self.colorTypeId;
			text = self.textArea:GetText(),
			color = self.colorid,
			rgb0 = self.color0Selector:GetRGB(),
			rgb1 = self.color1Selector:GetRGB(),
			rgb2 = self.color2Selector:GetRGB(),
			command = self.commandid,
			dest = self.destArea:GetText();
		};
		Savesettings();
	end
	self.colortagBtn = Turbine.UI.Label();
	self.colortagBtn:SetParent( self );
	self.colortagBtn:SetBackground( "WalmPlugins/PimpYourText/pictures/tag.jpg" );
	self.colortagBtn:SetSize(16, 16);
	--self.colortagBtn.tooltip = ToolTip(self.colortagBtn, "Tag : ", _("TAG_BTN"), ToolTipLayout.SMALL_TEXTONLY);
	self.colortagBtn.tooltip = GenericTooltip(self.colortagBtn);
	self.colortagBtn.tooltip:AddLayer(_("TAG_BTN"), Turbine.UI.Color(1,1,1), Turbine.UI.ContentAlignment.TopLeft, Turbine.UI.Lotro.Font.Verdana14, nil);		
	self.colortagBtn.MouseClick = function(sender, args)
		-- <rgb=#FF5CCD>
		if(self.selectedColor==self.colorList[table.getn(self.colorList)-1]) then
			Turbine.Shell.WriteLine(_("ERROR_COLOR1"));
		elseif (self.selectedColor==1) then
			Turbine.Shell.WriteLine(_("ERROR_COLOR2"));
		else
			if(self.textArea:GetSelectionLength()==0) then
				self.textArea:InsertText("<rgb=#"..self.color0Selector:GetRGB()..">");
			else
				local tmp = self.textArea:GetSelectedText();
				self.textArea:SetSelectedText("<rgb=#"..self.color0Selector:GetRGB()..">"..tmp.."</rgb>");
			end
		end
		self:UpdateValidationButton();
	end	
		
end

-- Build the sending button
function PimpYourTextDialog:CreateGeneratorComponents()
	-- This is the Quickslot, the shortcut container
	self.qsValid = Turbine.UI.Lotro.Quickslot();
	self.qsValid:SetParent(self);
	self.qsValid:SetSize(78,44);
	self.qsValid:SetPosition(260, 142);
	self.qsValid:SetVisible(true);	
	--self.qsValid:SetBackColor( Turbine.UI.Color( 0.6, 0, 0, 0 ) );
	--self.qsValid:SetBackground( "WalmPlugins/PimpYourText/role_button_normal.tga");
	self.qsValid:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "/raid <rgb=#FF5CCD>TEMP MSG :P</rgb>"));	-- rose = FF5CCD
	self.qsValid:SetAllowDrop(false);
	self.qsValid:SetEnabled(false);
	
	-- A basic control on the quickslot for cosmetic purpose
	self.qsLbl = Turbine.UI.Control();
	self.qsLbl:SetParent(self);
	self.qsLbl:SetSize(self.qsValid:GetSize());
	self.qsLbl:SetPosition(self.qsValid:GetLeft(),self.qsValid:GetTop());
	self.qsLbl:SetMouseVisible(false);
	self.qsLbl:SetZOrder(10000);
	
	-- A basic label on the basic control for cosmetic purpose ++
	c= Turbine.UI.Label()
	c:SetParent(self.qsLbl);
	c:SetPosition(1,1);
	c:SetForeColor(Turbine.UI.Color( 1, 223/255, 0 ));
	c:SetSize(self.qsLbl:GetWidth()-2,self.qsLbl:GetHeight()-2);
	c:SetFontStyle(Turbine.UI.FontStyle.Outline);
	c:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	c:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	c:SetBackground( "WalmPlugins/PimpYourText/pictures/role_button_normal.tga");
	c:SetMouseVisible(false);
	c:SetZOrder(10001);
	c:SetText(_("SENDMESSAGE"));	
end

-- Update the sending button
function PimpYourTextDialog:UpdateValidationButton()
	local text = FromUTF8(self.textArea:GetText());
	
	if(self.colorTypeId==2) then
		local rainbowList={"FF0000", "FFFF00", "00FF00", "38E5DF", "FF5CCD", "FF00FF"};
		local str = "";
		local colorCount = table.getn(rainbowList);
		local dec = math.random(colorCount);
		for i = 1, text:len() do
			local c = text:sub(i,i);
			if(c==" " or c=="\n") then
				str = str..c;
			else
				str = str.."<rgb=#"..rainbowList[(i+dec)%colorCount+1]..">"..c;
			end			
		end	
		text = str;
	elseif(self.colorTypeId==3)then
		local str = "";
		local rgb1 = self.color1Selector:GetRGB();
		local rgb2 = self.color2Selector:GetRGB();
		if(string.len(rgb1)~=6) then
			rgb1 = "FFFFFF";
		end
		if(string.len(rgb2)~=6) then
			rgb2 = "FFFFFF";
		end
		local r1 = self.color1Selector:GetByte(rgb1, 1);
		local g1 = self.color1Selector:GetByte(rgb1, 2);
		local b1 = self.color1Selector:GetByte(rgb1, 3);
		local r2 = self.color2Selector:GetByte(rgb2, 1);
		local g2 = self.color2Selector:GetByte(rgb2, 2);
		local b2 = self.color2Selector:GetByte(rgb2, 3);
		for i = 1, text:len() do
			local c = text:sub(i,i);
			if(c==" " or c=="\n") then
				str = str..c;
			else
				str = str.."<rgb=#"..self:ToRGB(
					r1+i*(r2-r1)/text:len(), 
					g1+i*(g2-g1)/text:len(), 
					b1+i*(b2-b1)/text:len() )..">"..c;
			end			
		end
		text = str;
	else
		text = "<rgb=#".. self.color0Selector:GetRGB() .. ">"..text;
	end
	
	-- Apply MI command
	if(self.commandList[table.getn(self.commandList)]==self.command) then
		self.command = self.command.." "..self.destArea:GetText();
	end
	-- Apply Message of the Day command
	if(self.commandList[table.getn(self.commandList)-1]==self.command) then
		text = "\""..text.."\"";
	end	
	
	self.qsValid:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, self.command.." "..text));
end

function PimpYourTextDialog:ToRGB(r, g, b)
	local str = "";
	local a1; local a2;
	a1 = math.floor(r/16);
	a2 = r%16;
	if(a1<10) then str=str..string.char(a1+48); else str=str..string.char(a1+55); end
	if(a2<10) then str=str..string.char(a2+48); else str=str..string.char(a2+55); end
	a1 = math.floor(g/16); a2=g%16;
	if(a1<10) then str=str..string.char(a1+48); else str=str..string.char(a1+55); end
	if(a2<10) then str=str..string.char(a2+48); else str=str..string.char(a2+55); end
	a1 = math.floor(b/16); a2=b%16;
	if(a1<10) then str=str..string.char(a1+48); else str=str..string.char(a1+55); end
	if(a2<10) then str=str..string.char(a2+48); else str=str..string.char(a2+55); end
	--Turbine.Shell.WriteLine("conv "..r..","..g..","..b.."="..(str or "nihil"));
	return str;
end

-- reload components data
function PimpYourTextDialog:SwitchTab(delta, firstload)
	if (delta==nil) then return; end;
	
	local previousTabId = self.tabLabel.selectedValue;
	self.tabLabel.selectedValue = 1+(self.tabLabel.selectedValue-1+delta) % 8 ;
	self.tabLabel:SetText(self.tabLabel.selectedValue);
	local loadDefaultValues = false;
	
	if(previousTabId==self.tabLabel.selectedValue) then -- on recharge depuis les fichiers de config
		if(settings.loadData~=nil and settings.loadData[self.tabLabel.selectedValue]~=nil) then
			self.textArea:SetText(settings.loadData[self.tabLabel.selectedValue].text);
			self.destArea:SetText(settings.loadData[self.tabLabel.selectedValue or 1].dest);
			self.commandid = settings.loadData[self.tabLabel.selectedValue or 1].command;
			self.command = self.commandList[self.commandid or 1];
			self.commandDropDown:SetLabel(self.canalList[self.commandid]);
			self.colorTypeId = settings.loadData[self.tabLabel.selectedValue].colorTypeId;
			self.colorTypeDropDown:SetLabel( self.colorTypeList[self.colorTypeId or 1] );
			self.color0Selector:SetRGB(settings.loadData[self.tabLabel.selectedValue].rgb0);
			self.color1Selector:SetRGB(settings.loadData[self.tabLabel.selectedValue].rgb1);
			self.color2Selector:SetRGB(settings.loadData[self.tabLabel.selectedValue].rgb2);
			self.colorTypeDropDown:SetLabel( self.colorTypeList[self.colorTypeId or 1] );
			--self.commandDropDown:SetLabel(self.canalList[self.commandid or 1]);
			--self.color1Area:SetText(settings.loadData[self.tabLabel.selectedValue].rgb);
			--self.colorid = settings.loadData[self.tabLabel.selectedValue].color;
			--self.selectedColor = self.colorList[self.colorid];
			--self.color1DropDown:SetLabel(self.colorList[self.colorid]);	
		else -- default values
			loadDefaultValues = true;		
		end
	
	else 
		if(firstload~=true) then
			if(self.localBuffer[previousTabId] == nil) then self.localBuffer[previousTabId] = {}; end
			self.localBuffer[previousTabId].text = self.textArea:GetText();
			--self.localBuffer[previousTabId].rgb = self.color1Area:GetText();
			self.localBuffer[previousTabId].command = self.commandid;
			self.localBuffer[previousTabId].dest = self.destArea:GetText();
			self.localBuffer[previousTabId].colorTypeId = self.colorTypeId;
			self.localBuffer[previousTabId].rgb0 = self.color0Selector:GetRGB();
			self.localBuffer[previousTabId].rgb1 = self.color1Selector:GetRGB();
			self.localBuffer[previousTabId].rgb2 = self.color2Selector:GetRGB();
			--self.localBuffer[previousTabId].color = self.colorid;
		end
		if(self.localBuffer[self.tabLabel.selectedValue]~=nil and self.localBuffer[self.tabLabel.selectedValue].text~=nil) then 
			-- chargement des données depuis le buffer / self.localBuffer[self.tabLabel.selectedValue]
			self.textArea:SetText(self.localBuffer[self.tabLabel.selectedValue].text);
			--self.colorArea:SetText(self.localBuffer[self.tabLabel.selectedValue].rgb);
			self.destArea:SetText(self.localBuffer[self.tabLabel.selectedValue].dest);
			self.commandid = self.localBuffer[self.tabLabel.selectedValue].command;
			self.commandDropDown:SetLabel(self.canalList[self.commandid]);
			self.command = self.commandList[self.commandid];
			self.colorTypeId = self.localBuffer[self.tabLabel.selectedValue].colorTypeId;
			self.colorTypeDropDown:SetLabel( self.colorTypeList[self.colorTypeId or 1] );
			self.color0Selector:SetRGB(self.localBuffer[self.tabLabel.selectedValue].rgb0);
			self.color1Selector:SetRGB(self.localBuffer[self.tabLabel.selectedValue].rgb1);
			self.color2Selector:SetRGB(self.localBuffer[self.tabLabel.selectedValue].rgb2);			
			--self.colorid = self.localBuffer[self.tabLabel.selectedValue].color;
			--self.selectedColor = self.colorList[self.colorid];
			--self.colorDropDown:SetLabel(self.colorList[self.colorid]);		
		elseif (settings.loadData~=nil and settings.loadData[self.tabLabel.selectedValue]~=nil) then
			-- chargement des données depuis le fichier de sauvegarde
			self.textArea:SetText(settings.loadData[self.tabLabel.selectedValue].text);
			--self.colorArea:SetText(settings.loadData[self.tabLabel.selectedValue].rgb);
			self.destArea:SetText(settings.loadData[self.tabLabel.selectedValue].dest);
			self.commandid = settings.loadData[self.tabLabel.selectedValue].command;
			self.commandDropDown:SetLabel(self.canalList[self.commandid]);
			self.command = self.commandList[self.commandid];
			self.colorTypeId = settings.loadData[self.tabLabel.selectedValue].colorTypeId or 1;
			self.colorTypeDropDown:SetLabel( self.colorTypeList[self.colorTypeId or 1] );
			self.color0Selector:SetRGB(settings.loadData[self.tabLabel.selectedValue].rgb0);
			self.color1Selector:SetRGB(settings.loadData[self.tabLabel.selectedValue].rgb1);
			self.color2Selector:SetRGB(settings.loadData[self.tabLabel.selectedValue].rgb2);				
			--self.colorid = settings.loadData[self.tabLabel.selectedValue].color;
			--self.selectedColor = self.colorList[self.colorid];
			--self.colorDropDown:SetLabel(self.colorList[self.colorid]);
		else
			loadDefaultValues = true;	
		end
	end
	
	
	if loadDefaultValues == true then
		self.textArea:SetText(_("DEFAULT_TXT"));
		--self.colorArea:SetText("");
		self.destArea:SetText("");
		self.commandid = 1;
		self.commandDropDown:SetLabel(self.canalList[self.commandid]);
		self.command = self.commandList[self.commandid];
		self.colorTypeId = 1;
		self.colorTypeDropDown:SetLabel( self.colorTypeList[self.colorTypeId or 1] );
		--self.colorid = 1;
		--self.selectedColor = self.colorList[self.colorid];
		--self.colorDropDown:SetLabel(self.colorList[self.colorid]);	
	end
	-- if(settings.loadData~=nil and settings.loadData[1]~=nil) then
		-- self.textArea:SetText(settings.loadData[1].text);
	-- else
		-- self.textArea:SetText("Ecrivez ici votre message");
	-- end	
	self.color0Selector:SetVisible(self.colorTypeId==1 or self.colorTypeId==nil);
	self.color1Selector:SetVisible(self.colorTypeId==3);
	self.color2Selector:SetVisible(self.colorTypeId==3);
	self.colortagBtn:SetVisible(self.colorTypeId==1 or self.colorTypeId==nil);
	self.destArea:SetEnabled(self.commandid==table.getn(self.canalList));
	self.destArea:SetVisible(self.commandid==table.getn(self.canalList));
	self:UpdateValidationButton();
	
	settings.currenttab = self.tabLabel.selectedValue;
	Savesettings();
end

function PimpYourTextDialog:GetName()
	return "PimpYourText";
end

function PimpYourTextDialog:IsRunning()
	return ( self ~= nil );
end

function PimpYourTextDialog:Start()
	if(self~=nil) then 
		self:SetVisible(true); 
	end
end

function PimpYourTextDialog:Stop()
	self = nil;
end

function PimpYourTextDialog:UpdateResponsive()
	self.destArea:SetWidth(self:GetWidth()-140-135);
	self.resizer:SetPosition(self:GetWidth()-45, self:GetHeight()-45);
	self.textArea:SetSize( self:GetWidth()-self.textArea:GetLeft()*2-10, self:GetHeight()-140);
	self.textArea:GetVerticalScrollBar():SetLeft( self.textArea:GetLeft()+self.textArea:GetWidth() );
    self.textArea:GetVerticalScrollBar():SetHeight( self.textArea:GetHeight() );
	self.tabLabel:SetTop(self.textArea:GetTop()+self.textArea:GetHeight()/2-self.tabLabel:GetHeight()/2);
	self.upBtn:SetTop(self.tabLabel:GetTop()-20);
	self.downBtn:SetTop(self.tabLabel:GetTop()+25);
	
	self.qsValid:SetPosition(self:GetWidth()-self.qsValid:GetWidth()-40, self:GetHeight()-self.qsValid:GetHeight()-36);
	self.qsLbl:SetPosition(self.qsValid:GetLeft(), self.qsValid:GetTop());
	
	self.colortagBtn:SetPosition( self:GetWidth()-23, self.textArea:GetTop()+self.textArea:GetHeight()/2-self.colortagBtn:GetHeight()/2);	
	self.resetBtn:SetPosition( self.colortagBtn:GetLeft(), self.colortagBtn:GetTop() + 18 );
	self.saveBtn:SetPosition( self.colortagBtn:GetLeft(), self.colortagBtn:GetTop() - 18);
	
	self.colorTypeDropDown:SetPosition( self.textArea:GetLeft(), self:GetHeight()-80);
	self.color0Selector:SetPosition(self.colorTypeDropDown:GetLeft(), self.colorTypeDropDown:GetTop()+22)
	self.color1Selector:SetPosition(self.colorTypeDropDown:GetLeft(), self.colorTypeDropDown:GetTop()+22)
	self.color2Selector:SetPosition(self.color1Selector:GetLeft(), self.color1Selector:GetTop()+22)
	-- self.color1DropDown:SetPosition( self.colorTypeDropDown:GetLeft(), self.colorTypeDropDown:GetTop()+24);
	-- self.color1Area:SetPosition( self.color1DropDown:GetLeft()+130 , self.color1DropDown:GetTop()-1);
	-- self.color2DropDown:SetPosition( self.color1DropDown:GetLeft(), self.color1DropDown:GetTop()+24);
	-- self.color2Area:SetPosition( self.color2DropDown:GetLeft()+130 , self.color2DropDown:GetTop()-1);	
end